plugins['keeprecording'] = (function() {

    return { 

        loadLang: function(values) {
            var hash = hex_md5(secret+lastkey);
            queuedcommand = "<msg data=\"" + myposition + "|pluginlang|" + language + "~keeprecording" + "|" + hash + "\" />";
            sendcommand();
        },

        setLang: function() {
            // change language strings
            $('#action_keeprecording').attr('title',lang.keeprecording);
            setTips($('#action_keeprecording'));
        },

        embed: function() {
            // embed elements in page, load style files
            if($('#action_keeprecording').length == 0) {
                var actionbar = $('#custombar');
                but = document.createElement('div');
                $(but).attr({id: 'action_keeprecording', title: 'Keep Recording'}).addClass('actionbutton myclick');
                img = document.createElement('img');
                $(img).attr('src','./admin/plugins/keeprecording/images/keepbutton.png');
                $(but).append(img);
                actionbar.append(but);
            }
        },

        action_keeprecording: function(target) {
            debug('do keeprecording ');

            if (myposition > 0) {
                var boton = $('#boton' + myposition);

                if (boton.hasClass('busy')) {
                    var hash = hex_md5(secret+lastkey);
                    queuedcommand = "<msg data=\"" + myposition + "|customkeeprecording||" + hash + "\" />";
                    sendcommand();
                } else {
                    debug("You are not on a call, we only send this command when we are busy");
                }
            }
 
        },
        callback_keeprecording: function(nro,texto,slot) {
            // when receiving the userevent keeprecording fired from the action response in the pl side
            if(myposition == nro) {
                if(texto==1) {
                    $('#action_keeprecording').addClass('flash');
                } else {
                    $('#action_keeprecording').removeClass('flash');
                }
            }
        },
        callback_state: function(nro,texto,slot) {
            if(myposition == nro) {
                 var estados = texto.split("+");
                 if (jQuery.inArray('DOWN', estados) >= 0) {
                     if (slot == "0") {
                         $('#action_keeprecording').removeClass('flash');
                     }
                 }
             }
        },

        init: function() {
            // initialization function
            this.embed();
            this.loadLang();
        }
    }
}());
