$date = localtime();
# print "date is $date \n"; 

	# create callback (whatever that could be)
$Client_Post_Command_Handler{'keeprecording'}{'customkeeprecording'} = sub { 
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;

#    print "----source $origen destination $destino context $contexto\n";

	#get fop2 buttons configuration from $context, $origin, 'HEADER'
	# $contexto is the tenant/context
	# $origin is the button number position that originates or makes the request
	# HEADER is the button header as in buttons.cfg
	# MAINCHANNEL 
    my $mychannel      = main::get_btn_config( "$contexto", $origen, 'MAINCHANNEL');
    my $activechannel  = main::get_active_chan($mychannel);
    my $bridgechannel  = main::get_active_link($mychannel);

    if ($bridgechannel =~ m/^Local/i) {
        my $newchan = $canal = FOP2::utils::get_channel($bridgechannel);
        $bridgechannel  = main::get_active_link($newchan);
    }

#    print "----my channel $mychannel active $activechannel bridge $bridgechannel\n";

#    if ( !main::hasPermChannel( $socket, "monitor", $mychannel ) && !main::hasPerm( $socket, "all" ) ) {
#        # No 'dial' permission, abort action
#        print "---No permissions for pausing the recording. Requires monitor or all.\n";
#        return @allreturn;
#   }

    # Keep internal track of state, so we can iterate between states

    if(defined($main::pluginvariable{'keeprecording'}{'iskept'}{$mychannel})) 
    {
        $kept = $main::pluginvariable{'keeprecording'}{'iskept'}{$mychannel};
   #     print "---State keeprecording $kept $mychannel is defined and has value: $kept\n";
    } else {
        $kept = 0;
  #      print "---State keeprecording $kept $mychannel is not defined and I start from value: $kept\n";
    }

    # Toggle state
	#    $kept ^= 1;
    # oryginal plugin was changing value to 1 and 0. for me once button is pressed (no matter how many times)
    # it should change value for keeprecording to yes (1)
	$kept = 1;
    
    $main::pluginvariable{'keeprecording'}{'iskept'}{$mychannel} = $kept;

    # Special construction in ActionID in order to catch the Action response
    # so we can fire a UserEvent in case command succeeds
    # show current values
 #   print "--- action setvar  channel: $bridgechannel variable: keeprecording, value $kept\n";

    my $return = {
        Action    => 'Setvar',
        Channel   => $bridgechannel,
        Variable  => 'keeprecording',
        Value => $kept,
        ActionID  => "Setvar!$bridgechannel!$mychannel!$kept"
    };
   
    # push appends list of values called ("$returns")  to array called "allreturn"

    push @allreturn, $return;
    $return = {
        Action    => 'Setvar',
        Channel   => $activechannel,
	Variable  => 'keeprecording',
        Value     => $kept,
        ActionID  => "Setvar!$activechannel!$mychannel!$kept"
    };
#      print "--- action setvar channel: $activechannel  variable: keeprecording value $kept\n";

    push @allreturn, $return;

#    print Dumper @allreturn;
    return @allreturn;
   };

# Catching a command response
$AMI_Response_Handler{'keeprecording'}{'Setvar'} = sub { 

     my $response = shift;
     my $extra    = shift;

     my @allreturn;
     my ($aid0, $activechannel, $mychannel, $iskept)   = split/!/, $extra;
     print "$aid0 $activechannel $mychannel  $iskept\n";

#   print Dumper $response;

     if($response->{Response} eq "Success") {
	# Fire a UserEvent on comand success to notify the client that mixmonitor mute is active or inactive
        my $valor = { 'Action' => 'UserEvent', 'UserEvent' => 'KeepRecordingComplete', 'Channel' => $mychannel, 'Family' => "keeprecording", 'Value' => $iskept
        };

	print "----value for valor is $valor\n";
        push @allreturn, $valor;
     };
     return @allreturn;
};

$AMI_Event_Handler{'keeprecording'}{'HANGUP'} = sub {
	print "----Hangup event handler\n";
    my $event = shift;
    my @allreturn;

    my $canal = FOP2::utils::get_channel(${$event}{Channel});
    delete $main::pluginvariable{'keeprecording'}{'iskept'}{$canal};
    return @allreturn;
};

#execute subroutine 
#Client_Post_Command_Handler();
